;blockhead v0

.MEMORYMAP
DEFAULTSLOT 0
SLOTSIZE $8000
SLOT 0 $0000
.ENDME

.ROMBANKMAP
BANKSTOTAL 1
BANKSIZE $8000
BANKS 1
.ENDRO

.sdsctag 1.00,"blockhead","?","proppy"

.bank 0 slot 0

.define SatSize  6
.define LifeCount 7
.define SlotSize LifeCount + 1
.define BlockCount 10

.enum $c000
y0 db
x0 db
n0 db
y1 DB
x1 db
n1 db
.ende
.enum $c000
sat dsb SatSize
slot dsb SlotSize
input db
timeout db
life db
scroll db
seed db
frame db
.ende

.define STATE    $c1
.define YPOS     $c2
.define XPOS     $c3
.define NTILE    $c4
.define JUMP     $c5
.enum $c100
stateBlock dsb BlockCount
.ende
.enum $c200
yBlock dsb BlockCount
.ende
.enum $c300
xBlock dsb BlockCount
.ende
.enum $c400
nBlock dsb BlockCount
.ende

.org $0000
di
im 1
jp Main
.org $0008
; send vdp command from hl
ld a, l
out ($bf), a
ld a, h
out ($bf), a
ret
.org $0010
; send vdp command from de
ld a, e
out ($bf), a
ld a, d
out ($bf), a
ret
.org $0018
ret
.org $0020
ret
.org $0028
ret
.org $0100
jp UpdateNone
nop
jp UpdateDown
nop
jp UpdateUp
nop

UpdateNone:
ld a, (x0)
ld b, XPOS
ld (bc), a
jp RenderBlock

UpdateDown:
ld b, YPOS
ld a, (bc)
dec a
ld (bc), a
; collide test
jp RenderBlock

UpdateUp:
ld b, YPOS
ld a, (bc)
inc a
ld (bc), a
; collide test
jp RenderBlock

RenderBlock:
push hl
push bc
jp +
ld b, YPOS
ld a, (bc)
ld h, a
ld b, XPOS
ld a, (bc)
ld l, a
ld b, NTILE
ld a, (bc)
ld d, a
ld e, $0f
+
ld hl, $2020
ld d, $0c
ld e, $05
call SpriteSet16x16
pop bc
pop hl
jp EndTestUpdateBlock
;jp NextBlock

Main:
ld sp, $dff0    ; init stack

InitVdpRegs:
ld hl, VdpRegs
ld b, EndVdpRegs - VdpRegs
ld c, $bf
otir

LoadPalettes:
ld de, $c000    ; VdpCommand : CRAM write at $0000
ld hl, BgPal
ld b, EndBgPal - BgPal
call VdpCopy

LoadBgRockPal
ld de, $c000 + $04
ld hl, BgRockPal
ld b, EndBgRockPal - BgRockPal
call VdpCopy

LoadBgEtoilePal
ld de, $c000 + $08
ld hl, BgEtoilePal
ld b, EndBgEtoilePal - BgEtoilePal
call VdpCopy

;LoadMartianPal:
;ld de, $c000 + $04   ; VdpCommand : CRAM write at $0000
;ld hl, MartianPal
;ld b, EndMartianPal - MartianPal
;call VdpCopy

LoadStreumonPal:
ld de, $c010    ; VdpCommand : CRAM write at $0010
ld hl, StreumonPal
ld b, EndStreumonPal - StreumonPal
;ld hl, SpritePal
;ld b, EndSpritePal - SpritePal
call VdpCopy

LoadTiles:
;ld de, $4000    ; VdpCommand : VRAM write at $0000
;ld hl, Tiles
;ld b, EndTiles - Tiles
;call LoadTile2Bpp
ld de, $4000 + (EndTiles - Tiles)*2   ; VdpCommand : VRAM write at $0000


LoadStreumonTiles:
ld hl, StreumonTiles + 32 + 32
call LoadTile2Bpp16x16Sprite4Stripped
ld hl, StreumonTiles + 32 + 32 +32
call LoadTile2Bpp16x16Sprite4Stripped
ld hl, StreumonTiles
call LoadTile2Bpp16x16Sprite4Stripped
ld hl, StreumonTiles + 32
call LoadTile2Bpp16x16Sprite4Stripped

;LoadMartianTiles:
;ld hl, MartianTiles
;ld b, EndMartianTiles - MartianTiles
;ld c, $01
;call LoadTile2Bpp
LoadBgRockTiles:
ld hl, BgRockTiles
ld b, $fe
ld c, $01
call LoadTile2Bpp
ld hl, BgRockTiles + $fe
ld b, EndBgRockTiles - (BgRockTiles + $fe)
ld c, $01
call LoadTile2Bpp

ld hl, BgEtoileTiles
ld b, EndBgEtoileTiles - BgEtoileTiles
ld c, $02
call LoadTile2Bpp

LoadMap:
LoadBgRockMap
ld de, $7700  ; why 0 command don't work ?
rst $10
ld hl, BgRockMap
ld bc, EndBgRockMap - BgRockMap
ld d, $14
ld e, $ff
call LoadTileMap
LoadBgEtoileMap:
ld de, $7700
rst $10
ld hl, BgEtoileMap
ld bc, EndBgEtoileMap - BgEtoileMap
ld d, $2e
ld e, $00
call LoadTileMap

;ld hl, MartianMap
;ld bc, EndMartianMap-MartianMap
;ld d, $14
;call LoadTileMap

InitSprite:
ld de, sat
ld hl, SpriteInit
ld bc, EndSpriteInit - SpriteInit
ldir

InitSlot:
ld hl, slot
ld (hl), $00
ld de, slot + 1
ld bc, SlotSize - 1
ldir

InitInput:
ld a, $ff
ld (input), a

InitTimeout:
ld a, $ff
ld (timeout), a

InitLife:
ld a, LifeCount
ld (life), a

InitScroll:
xor a
ld (scroll), a

InitSeed:
xor a
ld (seed), a

InitFrame:
xor a
ld (seed), a

InitBlock:
ld hl, stateBlock
ld (hl), $00
ld de, stateBlock + 1
ld bc, BlockCount - 1
ldir
ld hl, yBlock
ld (hl), $00
ld de, stateBlock + 1
ld bc, BlockCount - 1
ldir
ld hl, xBlock
ld (hl), $00
ld de, stateBlock + 1
ld bc, BlockCount - 1
ldir
ld hl, nBlock
ld (hl), $00
ld de, stateBlock + 1
ld bc, BlockCount - 1
ldir

InitTestBlock:
ld c, $0f
ld b, STATE
ld a, 1
ld (bc), a
ld b, YPOS
ld a, $20
ld (bc), a
ld b, XPOS
ld a, $20
ld (bc), a
ld b, NTILE
ld a, $0c
ld (bc), a
Game:

WaitBeginVBlank:
ld c, $c0
call WaitVCount

Update:

UpdateBlock:
jp EndUpdateBlock
ld b, STATE
ld c, $0f
ld h, $01
ld l, $00
-:
ld b, STATE
ld a, (bc)
rla
rla
jp z, NextBlock
ld l, a
jp (hl)
NextBlock:
dec c
jp nz, -
EndUpdateBlock:

TestUpdateBlock:
ld hl, $0000
ld d, $04
ld e, $0f
call SpriteSet16x16

EndTestUpdateBlock:

UpdateInput:
ld a, (input)
ld b, a
in a, ($dc)
ld c, a
and b
    ld d, a
; b hold old input
; c hold new input
; d hold masked input
cp b
ld a, d
ld (input), a
ld a, (timeout)
jp z, InputNotChanged

InputChanged:
cp $ff
jp nz, UpdatePlayer  ; if already moving dont reset timeout
;ld a, $08
ld a, $10
jp UpdateTimeout

InputNotChanged:
cp $ff               ; moving ?
jp z, UpdatePos      ; if not then skip UpdatePlayer

UpdatePlayer:
dec a                ; dec timeout
;jp nz, UpdateTimeout ; is it 0 ?
jp z, UpdatePlayerPos
;ex af, af'
push af

ld a, d
and $04
jp nz, +
;ex af, af'
pop af
push af
cp $08
jp nc, ++
ld c, $ff
jp +++
++
ld c, $ff - $01
;ex af, af'
pop af
dec a
;ex af, af'
push af
+++
+
ld a, d
and $08
jp nz, +
;ex af, af'
pop af
push af
cp $08
jp nc, ++
ld c, $01
jp +++
++
ld c, $02
;ex af, af'
pop af
dec a
;ex af, af'
push af
+++
+
;ex af, af'
pop af
push af
ld a, (x0)
add a, c
ld (x0), a

pop af
jp UpdateTimeout ; is it 0 ?

UpdatePlayerPos:     ; then update pos
ld a, d
and $04
jp nz, +
ld c, $ff; - $08 + $00;$ff - $10 + $01  ; c = -8
+
ld a, d
and $08
jp nz, +
ld c, $01;$09;$10
+
ld a, (x0)
add a, c
ld (x0), a

ResetInput:
ld a, $ff            ; reset input mask
ld (input), a
ResetTimeout:        ; reset timeout to (notmoving $ff)
ld a, $ff
UpdateTimeout:


ld (timeout), a      ; overwrite timeout

UpdatePos:
ld a, (y1)
inc a
ld (y1), a

UpdateSat:
;ld hl, sat    ; SAT mirror addr
;ld e, $00     ; sprite no
;ld b, SatSize ; SAT size
;call SATSet
;0100
;1100

;01100
;10000

;01100
;11100
;10000

;0 4 8 12
;1000

ld hl, (sat)
ld a, (sat+2)
ld d, a
ld e, 0
call SpriteSet16x16

ld hl, (sat+3)
ld a, (sat+3+2)
ld d, a
ld e, 4
call SpriteSet16x16

ld a, (frame)
and $0f
jp nz, UpdateSlot

ld a, (sat+2)
xor $0c
ld (sat+2), a
ld a, (sat+3+2)
xor $1c
ld (sat+3+2), a

UpdateSlot:
ld hl, (sat)
ld bc, slot   ; slot indexer
ld e, $08
-
ld a, (bc)
ld d, a
ld a, l
sub $10
ld l, a
call SpriteSet16x16
inc c  ;next slot
ld a, e
add a, $4
ld e, a
;inc e  ;next sprite
ld a, e
cp (SlotSize + 3)*4
jp nz, -

CollisionTest:
YCollisionTest:
ld a, (life)
xor LifeCount
; life ^ 3 in c
ld c, a
inc a
; 4 - life in  c
add a, a
add a, a
add a, a
add a, a
ld b, a
;(4 - life) * 16 in b
ld a, (y1)
add a, b
ld b, a
;y1 + (4 - life) * 16 in b
ld a, (y0)
sub b
jp nz , NotCollide

XCollisionTest:
ld a, (x1)
ld b, a
ld a, (x0)
sub b
jp nz , NotCollide

Collide:
UpdateLife:
ld a, (life)
dec a
ld (life), a
jp z, End

AddBlockToSlot:
ld a, c
ld hl, slot
add a, l
ld l, a
ld a, $04
ld (hl), a

ResetBlock:
xor a
ld (y1), a
ld hl, seed
call Rand
and $f0
ld (x1), a

NotCollide:

UpdateScroll:
jp UpdateFrame
ld a, (scroll)
out ($bf), a
dec a
dec a
;and $0f ; ? why not 7
ld (scroll), a
ld a, $89     ; VdpCommand SetRegister(9) : v-scroll
out ($bf), a

UpdateFrame:
ld a, (frame)
inc a
ld (frame), a

WaitEndVBlank:
ld c, $00
call WaitVCount
jp Game

End:
-
jp -

VdpCopy:
; dest in de
; source in hl
; byte in b
rst $10
ld c, $be
otir
ret

LoadTile2Bpp16x16Sprite4Stripped:
ld b, $20
ld c, $00
call LoadTile2Bpp
ld bc, $20 * 3
add hl, bc
ld b, $20
ld c, $00
call LoadTile2Bpp
ret

LoadTile2Bpp:
; dest in de
; source in hl
; byte in b
rst $10
;ld c, $00
;ld c, $be
-
ld a, (hl)
out ($be), a
inc hl
ld a, (hl)
out ($be), a
inc hl

;outi
;outi
dec b
;dec b

ld a, c
and $01
neg
out ($be), a
ld a, c
rra
and $01
cp $00
neg
out ($be), a

inc de
inc de
inc de
inc de
djnz -
ret

LoadTileMap:
inc b
-:
;inc hl

ld a, (hl)
cp e
jp nz, +
in a, ($be)
in a, ($be)
inc hl
jp ++
+
add a, d
out ($be), a
inc hl
ld a, (hl)
out ($be), a
++
inc hl
dec c
dec c
jp nz, -
dec b
jp nz, -
ret

SATSet:
; sprite index in e
; hl point to first yxn or src SAT
; spriteCount*3 in b
ld c, $be
ld d, $7f
-
rst $10
outi
ld a, e
add a, a
or $80
out ($bf), a
ld a, d
out ($bf), a
inc e
outi
outi
jp nz, -
ret

SATSet16x16:
; sprite index in e
; hl point to first yxn or src SAT
; spriteCount in b

ld c, $be
ld d, $7f
;-
rst $10

;y
ld a, (hl)
out ($be), a
out ($be), a
add a, $08
out ($be), a
out ($be), a

ld a, e
add a, a
or $80
out ($bf), a
ld a, d
out ($bf), a

;push bc
;x
inc hl
ld a, (hl)
ld b, a ;x in b
inc hl
ld a, (hl)
ld c, a ;n in c

ld a, b
out ($be), a
ld a, c
out ($be), a

ld a, b
add a, $08
out ($be), a
inc c
ld a, c
out ($be), a

ld a, b
out ($be), a
inc c
ld a, c
out ($be), a

ld a, b
add a, $08
out ($be), a
inc c
ld a, c
out ($be), a

;pop bc

inc e
;dec b
;jp nz, -
ret

SpriteSet:
;x in h
;y in l
;n in d
;sprite index in e
ld a, e
out ($bf), a
ld a, $7f
out ($bf), a
ld a, l
out ($be), a
ld a, e
add a, a
or $80
out ($bf), a
ld a, $7f
out ($bf), a
ld a, h
out ($be), a
ld a, d
out ($be), a
ret

SpriteSet16x16:
;x in h
;y in l
;n in d
;sprite index in e

;vdp set addr
ld a, e
out ($bf), a
ld a, $7f
out ($bf), a

;y+0 y+0
;y+8 y+8
ld a, l
out ($be), a
out ($be), a
add a, $08
out ($be), a
out ($be), a

;vdp set addr
ld a, e
add a, a
or $80
out ($bf), a
ld a, $7f
out ($bf), a

;x+0 n+0 x+8 n+1
;x+0 n+2 x+8 n+3
ld a, h
out ($be), a
ld a, d
out ($be), a

ld a, h
add a, $08
out ($be), a
inc d
ld a, d
out ($be), a

ld a, h
out ($be), a
inc d
ld a, d
out ($be), a

ld a, h
add a, $08
out ($be), a
inc d
ld a, d
out ($be), a

ret


WaitVCount:
;wait VCount matches c
-
in a, ($7e)
--
ld b, a
in a, ($7e)
cp b
jp nz, --
cp c
jp nz, -
ret

Rand:
; seed addr in hl
ld a, (hl)
ld b, a
add a, a
add a, a
add a, b
inc a
;a = a * 5 + 1
ld (hl), a
ret

; data
VdpRegs:
.db $04,$80,$f0,$81,$0e,$82,$7e,$85,$00,$86,$0f,$87,$00,$88,$00,$89,$ff,$8a
EndVdpRegs:
; register 0
; register 1

BgPal:
.db $00,$3f,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
EndBgPal:

SpritePal:
.db $00,$03,$30,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
EndSpritePal:

Tiles: ; 2bpp
.db $00,$00
.db $00,$00
.db $00,$00
.db $00,$00
.db $00,$00
.db $00,$00
.db $00,$00
.db $00,$00

.db $ff,$00
.db $ff,$00
.db $ff,$00
.db $ff,$00
.db $ff,$00
.db $ff,$00
.db $ff,$00
.db $ff,$00

.db $00,$ff
.db $00,$ff
.db $00,$ff
.db $00,$ff
.db $00,$ff
.db $00,$ff
.db $00,$ff
.db $00,$ff

.db $ff,$ff
.db $ff,$ff
.db $ff,$ff
.db $ff,$ff
.db $ff,$ff
.db $ff,$ff
.db $ff,$ff
.db $ff,$ff
EndTiles:

SpriteInit:
.db $b0, $00, $04, $00, $00, $0c
EndSpriteInit:

StreumonPal:
.include "../inc/streumon_pal.inc"
EndStreumonPal:
StreumonTiles:
.include "../inc/streumon_tiles.inc"
EndStreumonTiles:

MartianPal:
.include "../inc/martian_pal.inc"
EndMartianPal:
MartianTiles:
.include "../inc/martian_tiles.inc"
EndMartianTiles:
MartianMap:
.include "../inc/martian_map.inc"
EndMartianMap:

BgRockPal:
.include "../inc/bg_rock_pal.inc"
EndBgRockPal:
BgRockTiles:
.include "../inc/bg_rock_tiles.inc"
EndBgRockTiles:
BgRockMap:
.include "../inc/bg_rock_map.inc"
EndBgRockMap:

BgEtoilePal:
.include "../inc/bg_etoile_pal.inc"
EndBgEtoilePal:
BgEtoileTiles:
.include "../inc/bg_etoile_tiles.inc"
EndBgEtoileTiles:
BgEtoileMap:
.include "../inc/bg_etoile_map.inc"
EndBgEtoileMap:


